org.apache.uima.fit.factory

## Class AnalysisEngineFactory

- java.lang.Object
- - org.apache.uima.fit.factory.AnalysisEngineFactory

-     public final class AnalysisEngineFactory
      extends Object

  A collection of static methods for creating UIMA `AnalysisEngineDescriptions` and `AnalysisEngines`.
  See Also:
    Why are descriptors better than component instances?

- - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static AnalysisEngine` | `createAggregate(AnalysisEngineDescription desc)` Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
    `static AnalysisEngine` | `createAggregate(List<AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, TypePriorities typePriorities, SofaMapping[] sofaMappings)` Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[])`
    `static AnalysisEngine` | `createAggregate(List<AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription)` Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
    `static AnalysisEngine` | `createAggregate(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription, Object... configurationData)` Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
    `static AnalysisEngine` | `createAggregate(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, Object... configurationData)` Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
    `static AnalysisEngineDescription` | `createAggregateDescription(AnalysisEngineDescription... analysisEngineDescriptions)` Deprecated. use `createEngineDescription(AnalysisEngineDescription...)`
    `static AnalysisEngineDescription` | `createAggregateDescription(FlowControllerDescription flowControllerDescription, AnalysisEngineDescription... analysisEngineDescriptions)` Deprecated. use `createEngineDescription(FlowControllerDescription, AnalysisEngineDescription...)`
    `static AnalysisEngineDescription` | `createAggregateDescription(List<AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription)` Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
    `static AnalysisEngineDescription` | `createAggregateDescription(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription, Object... configurationData)` Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
    `static AnalysisEngineDescription` | `createAggregateDescription(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, Object... configurationData)` Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
    `static AnalysisEngine` | `createAnalysisEngine(AnalysisEngineDescription analysisEngineDescription, String viewName)` Deprecated. use `createEngine(AnalysisEngineDescription, String)`
    `static AnalysisEngine` | `createAnalysisEngine(String descriptorName, Object... configurationData)` Deprecated. use `createEngine(String, Object...)`
    `static AnalysisEngineDescription` | `createAnalysisEngineDescription(String descriptorName, Object... configurationData)` Deprecated. use `createEngineDescription(String, Object...)`
    `static AnalysisEngineDescription` | `createAnalysisEngineDescriptionFromPath(String descriptorPath, Object... configurationData)` Deprecated. use `createEngineDescriptionFromPath(String, Object...)`
    `static AnalysisEngine` | `createAnalysisEngineFromPath(String descriptorPath, Object... configurationData)` Deprecated. use `createEngineFromPath(String, Object...)`
    `static AnalysisEngine` | `createEngine(AnalysisEngineDescription desc, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngine` | `createEngine(AnalysisEngineDescription analysisEngineDescription, String viewName)` This method provides a convenient way to instantiate an AnalysisEngine where the default view is mapped to the view name passed into the method.
    `static AnalysisEngine` | `createEngine(Class<? extends AnalysisComponent> componentClass, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngine` | `createEngine(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngine` | `createEngine(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, String[] typePriorities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngine` | `createEngine(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngine` | `createEngine(List<AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, TypePriorities typePriorities, SofaMapping[] sofaMappings)` Create and configure an aggregate `AnalysisEngine` from several component descriptions.
    `static AnalysisEngine` | `createEngine(List<AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription)` Create and configure an aggregate `AnalysisEngine` from several component descriptions.
    `static AnalysisEngine` | `createEngine(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static AnalysisEngine` | `createEngine(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static AnalysisEngine` | `createEngine(String descriptorName, Object... configurationData)` Get an AnalysisEngine from the name (Java-style, dotted) of an XML descriptor file, and a set of configuration parameters.
    `static AnalysisEngineDescription` | `createEngineDescription(AnalysisEngineDescription... analysisEngineDescriptions)` Create and configure an aggregate `AnalysisEngine` from several component descriptions.
    `static AnalysisEngineDescription` | `createEngineDescription(Class<? extends AnalysisComponent> componentClass, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngineDescription` | `createEngineDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngineDescription` | `createEngineDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, FsIndexCollection indexes, Capability[] capabilities, ConfigurationParameter[] configurationParameters, Object[] configurationValues)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngineDescription` | `createEngineDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, FsIndexCollection indexes, Capability[] capabilities, ConfigurationParameter[] configurationParameters, Object[] configurationValues, Map<String,ExternalResourceDescription> externalResources)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngineDescription` | `createEngineDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, FsIndexCollection indexes, Capability[] capabilities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngineDescription` | `createEngineDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, Object... configurationData)` Create and configure a primitive `AnalysisEngine`.
    `static AnalysisEngineDescription` | `createEngineDescription(FlowControllerDescription flowControllerDescription, AnalysisEngineDescription... analysisEngineDescriptions)` A simplified factory method for creating an aggregate description for a given flow controller and a sequence of analysis engine descriptions
    `static AnalysisEngineDescription` | `createEngineDescription(List<AnalysisEngineDescription> analysisEngineDescriptions, List<String> componentNames, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription)` A factory method for creating an aggregate description.
    `static AnalysisEngineDescription` | `createEngineDescription(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, FlowControllerDescription flowControllerDescription, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static AnalysisEngineDescription` | `createEngineDescription(List<Class<? extends AnalysisComponent>> componentClasses, TypeSystemDescription typeSystem, TypePriorities typePriorities, SofaMapping[] sofaMappings, Object... configurationData)` Create and configure an aggregate `AnalysisEngine` from several component classes.
    `static AnalysisEngineDescription` | `createEngineDescription(PearSpecifier pearSpecifier, Object... configurationData)` Get an `AnalysisEngineDescription` from a PEAR and a set of configuration parameters.
    `static AnalysisEngineDescription` | `createEngineDescription(String descriptorName, Object... configurationData)` Provides a way to create an AnalysisEngineDescription using a descriptor file referenced by name
    `static AnalysisEngineDescription` | `createEngineDescriptionFromPath(String descriptorPath, Object... configurationData)` Get an `AnalysisEngineDescription` from an XML descriptor file and a set of configuration parameters.
    `static AnalysisEngine` | `createEngineFromPath(String descriptorPath, Object... configurationData)` Get an `AnalysisEngine` from an XML descriptor file and a set of configuration parameters.
    `static AnalysisEngine` | `createPrimitive(AnalysisEngineDescription desc, Object... configurationData)` Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
    `static AnalysisEngine` | `createPrimitive(Class<? extends AnalysisComponent> componentClass, Object... configurationData)` Deprecated. use `createEngine(Class, Object...)`
    `static AnalysisEngine` | `createPrimitive(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, Object... configurationData)` Deprecated. use `createEngine(Class, TypeSystemDescription, Object...)`
    `static AnalysisEngine` | `createPrimitive(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, String[] typePriorities, Object... configurationData)` Deprecated. use `createEngine(Class, TypeSystemDescription, String[], Object...)`
    `static AnalysisEngine` | `createPrimitive(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, Object... configurationData)` Deprecated. use `createEngine(Class, TypeSystemDescription, TypePriorities, Object...)`
    `static AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass, Object... configurationData)` Deprecated. use `createEngineDescription(Class, Object...)`
    `static AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, Object... configurationData)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, Object...)`
    `static AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, FsIndexCollection indexes, Capability[] capabilities, ConfigurationParameter[] configurationParameters, Object[] configurationValues)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[])`
    `static AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, FsIndexCollection indexes, Capability[] capabilities, ConfigurationParameter[] configurationParameters, Object[] configurationValues, Map<String,ExternalResourceDescription> externalResources)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[], Map)`
    `static AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, FsIndexCollection indexes, Capability[] capabilities, Object... configurationData)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], Object...)`
    `static AnalysisEngineDescription` | `createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass, TypeSystemDescription typeSystem, TypePriorities typePriorities, Object... configurationData)` Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, Object...)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### createEngine

          public static AnalysisEngine createEngine(String descriptorName,
                                                    Object... configurationData)
                                             throws InvalidXMLException,
                                                    IOException,
                                                    ResourceInitializationException

      Get an AnalysisEngine from the name (Java-style, dotted) of an XML descriptor file, and a set of configuration parameters.
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        the `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAnalysisEngine

          @Deprecated
          public static AnalysisEngine createAnalysisEngine(String descriptorName,
                                                                        Object... configurationData)
                                                                 throws InvalidXMLException,
                                                                        IOException,
                                                                        ResourceInitializationException

      Deprecated. use `createEngine(String, Object...)`
      Get an AnalysisEngine from the name (Java-style, dotted) of an XML descriptor file, and a set of configuration parameters.
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        the `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(AnalysisEngineDescription analysisEngineDescription,
                                                    String viewName)
                                             throws ResourceInitializationException

      This method provides a convenient way to instantiate an AnalysisEngine where the default view is mapped to the view name passed into the method.
      Parameters:
        `analysisEngineDescription` - the analysis engine description from which the engine is instantiated
        `viewName` - the view name to map the default view to
      Returns:
        an aggregate analysis engine consisting of a single component whose default view is mapped to the the view named by viewName.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?, `AggregateBuilder`

    - #### createAnalysisEngine

          @Deprecated
          public static AnalysisEngine createAnalysisEngine(AnalysisEngineDescription analysisEngineDescription,
                                                                        String viewName)
                                                                 throws ResourceInitializationException

      Deprecated. use `createEngine(AnalysisEngineDescription, String)`
      This method provides a convenient way to instantiate an AnalysisEngine where the default view is mapped to the view name passed into the method.
      Parameters:
        `analysisEngineDescription` - the analysis engine description from which the engine is instantiated
        `viewName` - the view name to map the default view to
      Returns:
        an aggregate analysis engine consisting of a single component whose default view is mapped to the the view named by viewName.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?, `AggregateBuilder`

    - #### createEngine

          public static AnalysisEngine createEngine(AnalysisEngineDescription desc,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `desc` - the descriptor to create the analysis engine from.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static AnalysisEngine createAggregate(AnalysisEngineDescription desc)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
      Create an aggregate `AnalysisEngine`.
      Parameters:
        `desc` - the descriptor to create the analysis engine from.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static AnalysisEngine createPrimitive(AnalysisEngineDescription desc,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(AnalysisEngineDescription, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `desc` - the descriptor to create the analysis engine from.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(Class<? extends AnalysisComponent> componentClass,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static AnalysisEngine createPrimitive(Class<? extends AnalysisComponent> componentClass,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(Class, Object...)`
      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(Class<? extends AnalysisComponent> componentClass,
                                                    TypeSystemDescription typeSystem,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static AnalysisEngine createPrimitive(Class<? extends AnalysisComponent> componentClass,
                                                                   TypeSystemDescription typeSystem,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(Class, TypeSystemDescription, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(Class<? extends AnalysisComponent> componentClass,
                                                    TypeSystemDescription typeSystem,
                                                    String[] typePriorities,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities as an array of type names (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static AnalysisEngine createPrimitive(Class<? extends AnalysisComponent> componentClass,
                                                                   TypeSystemDescription typeSystem,
                                                                   String[] typePriorities,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(Class, TypeSystemDescription, String[], Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities as an array of type names (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(Class<? extends AnalysisComponent> componentClass,
                                                    TypeSystemDescription typeSystem,
                                                    TypePriorities typePriorities,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createPrimitive

          @Deprecated
          public static AnalysisEngine createPrimitive(Class<? extends AnalysisComponent> componentClass,
                                                                   TypeSystemDescription typeSystem,
                                                                   TypePriorities typePriorities,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(Class, TypeSystemDescription, TypePriorities, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(List<Class<? extends AnalysisComponent>> componentClasses,
                                                    TypeSystemDescription typeSystem,
                                                    TypePriorities typePriorities,
                                                    SofaMapping[] sofaMappings,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static AnalysisEngine createAggregate(List<Class<? extends AnalysisComponent>> componentClasses,
                                                                   TypeSystemDescription typeSystem,
                                                                   TypePriorities typePriorities,
                                                                   SofaMapping[] sofaMappings,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(List<Class<? extends AnalysisComponent>> componentClasses,
                                                    TypeSystemDescription typeSystem,
                                                    TypePriorities typePriorities,
                                                    SofaMapping[] sofaMappings,
                                                    FlowControllerDescription flowControllerDescription,
                                                    Object... configurationData)
                                             throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static AnalysisEngine createAggregate(List<Class<? extends AnalysisComponent>> componentClasses,
                                                                   TypeSystemDescription typeSystem,
                                                                   TypePriorities typePriorities,
                                                                   SofaMapping[] sofaMappings,
                                                                   FlowControllerDescription flowControllerDescription,
                                                                   Object... configurationData)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(List<AnalysisEngineDescription> analysisEngineDescriptions,
                                                    List<String> componentNames,
                                                    TypePriorities typePriorities,
                                                    SofaMapping[] sofaMappings)
                                             throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static AnalysisEngine createAggregate(List<AnalysisEngineDescription> analysisEngineDescriptions,
                                                                   List<String> componentNames,
                                                                   TypePriorities typePriorities,
                                                                   SofaMapping[] sofaMappings)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[])`
      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngine

          public static AnalysisEngine createEngine(List<AnalysisEngineDescription> analysisEngineDescriptions,
                                                    List<String> componentNames,
                                                    TypePriorities typePriorities,
                                                    SofaMapping[] sofaMappings,
                                                    FlowControllerDescription flowControllerDescription)
                                             throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAggregate

          @Deprecated
          public static AnalysisEngine createAggregate(List<AnalysisEngineDescription> analysisEngineDescriptions,
                                                                   List<String> componentNames,
                                                                   TypePriorities typePriorities,
                                                                   SofaMapping[] sofaMappings,
                                                                   FlowControllerDescription flowControllerDescription)
                                                            throws ResourceInitializationException

      Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
        `componentNames` - a list of names for the analysis engines in the aggregate. There must be exactly one name for each analysis engine, given in the same order as the descriptions.
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        an `AnalysisEngine` created from the specified component class and initialized with the configuration parameters.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngineFromPath

          public static AnalysisEngine createEngineFromPath(String descriptorPath,
                                                            Object... configurationData)
                                                     throws InvalidXMLException,
                                                            IOException,
                                                            ResourceInitializationException

      Get an `AnalysisEngine` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createAnalysisEngineFromPath

          @Deprecated
          public static AnalysisEngine createAnalysisEngineFromPath(String descriptorPath,
                                                                                Object... configurationData)
                                                                         throws InvalidXMLException,
                                                                                IOException,
                                                                                ResourceInitializationException

      Deprecated. use `createEngineFromPath(String, Object...)`
      Get an `AnalysisEngine` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngine` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`
        `ResourceInitializationException` - if a failure occurred during production of the resource.
      See Also:
        Why are descriptors better than component instances?

    - #### createEngineDescriptionFromPath

          public static AnalysisEngineDescription createEngineDescriptionFromPath(String descriptorPath,
                                                                                  Object... configurationData)
                                                                           throws InvalidXMLException,
                                                                                  IOException

      Get an `AnalysisEngineDescription` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngineDescription` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(PearSpecifier pearSpecifier,
                                                                          Object... configurationData)
                                                                   throws InvalidXMLException,
                                                                          IOException

      Get an `AnalysisEngineDescription` from a PEAR and a set of configuration parameters.
      Parameters:
        `pearSpecifier` - The PEAR specifier.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngineDescription` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createAnalysisEngineDescriptionFromPath

          @Deprecated
          public static AnalysisEngineDescription createAnalysisEngineDescriptionFromPath(String descriptorPath,
                                                                                                      Object... configurationData)
                                                                                               throws InvalidXMLException,
                                                                                                      IOException

      Deprecated. use `createEngineDescriptionFromPath(String, Object...)`
      Get an `AnalysisEngineDescription` from an XML descriptor file and a set of configuration parameters.
      Parameters:
        `descriptorPath` - The path to the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        The `AnalysisEngineDescription` created from the XML descriptor and the configuration parameters.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(String descriptorName,
                                                                          Object... configurationData)
                                                                   throws InvalidXMLException,
                                                                          IOException

      Provides a way to create an AnalysisEngineDescription using a descriptor file referenced by name
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. Will override configuration parameter settings in the descriptor file
      Returns:
        a description for this analysis engine.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createAnalysisEngineDescription

          @Deprecated
          public static AnalysisEngineDescription createAnalysisEngineDescription(String descriptorName,
                                                                                              Object... configurationData)
                                                                                       throws InvalidXMLException,
                                                                                              IOException

      Deprecated. use `createEngineDescription(String, Object...)`
      Provides a way to create an AnalysisEngineDescription using a descriptor file referenced by name
      Parameters:
        `descriptorName` - The fully qualified, Java-style, dotted name of the XML descriptor file.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. Will override configuration parameter settings in the descriptor file
      Returns:
        a description for this analysis engine.
      Throws:
        `IOException` - if an I/O error occurs
        `InvalidXMLException` - if the input XML is not valid or does not specify a valid `ResourceSpecifier`

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(Class<? extends AnalysisComponent> componentClass,
                                                                          TypeSystemDescription typeSystem,
                                                                          Object... configurationData)
                                                                   throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static AnalysisEngineDescription createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         Object... configurationData)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(Class<? extends AnalysisComponent> componentClass,
                                                                          Object... configurationData)
                                                                   throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static AnalysisEngineDescription createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass,
                                                                                         Object... configurationData)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, Object...)`
      Create and configure a primitive `AnalysisEngine`. The type system is detected automatically using `TypeSystemDescriptionFactory.createTypeSystemDescription()`. Type priorities are detected automatically using `TypePrioritiesFactory.createTypePriorities()`. Indexes are detected automatically using `FsIndexFactory.createFsIndexCollection()`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(Class<? extends AnalysisComponent> componentClass,
                                                                          TypeSystemDescription typeSystem,
                                                                          TypePriorities typePriorities,
                                                                          Object... configurationData)
                                                                   throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static AnalysisEngineDescription createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         TypePriorities typePriorities,
                                                                                         Object... configurationData)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(Class<? extends AnalysisComponent> componentClass,
                                                                          TypeSystemDescription typeSystem,
                                                                          TypePriorities typePriorities,
                                                                          FsIndexCollection indexes,
                                                                          Capability[] capabilities,
                                                                          Object... configurationData)
                                                                   throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. In addition to parameter names, external resource keys can also be specified. The value has to be an `ExternalResourceDescription` in that case.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static AnalysisEngineDescription createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         TypePriorities typePriorities,
                                                                                         FsIndexCollection indexes,
                                                                                         Capability[] capabilities,
                                                                                         Object... configurationData)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], Object...)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters. In addition to parameter names, external resource keys can also be specified. The value has to be an `ExternalResourceDescription` in that case.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(Class<? extends AnalysisComponent> componentClass,
                                                                          TypeSystemDescription typeSystem,
                                                                          TypePriorities typePriorities,
                                                                          FsIndexCollection indexes,
                                                                          Capability[] capabilities,
                                                                          ConfigurationParameter[] configurationParameters,
                                                                          Object[] configurationValues)
                                                                   throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static AnalysisEngineDescription createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         TypePriorities typePriorities,
                                                                                         FsIndexCollection indexes,
                                                                                         Capability[] capabilities,
                                                                                         ConfigurationParameter[] configurationParameters,
                                                                                         Object[] configurationValues)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[])`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is not null explicitly, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(Class<? extends AnalysisComponent> componentClass,
                                                                          TypeSystemDescription typeSystem,
                                                                          TypePriorities typePriorities,
                                                                          FsIndexCollection indexes,
                                                                          Capability[] capabilities,
                                                                          ConfigurationParameter[] configurationParameters,
                                                                          Object[] configurationValues,
                                                                          Map<String,ExternalResourceDescription> externalResources)
                                                                   throws ResourceInitializationException

      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is set explicitly here, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
        `externalResources` - external resources to bind to the analysis engine. (may be null)
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createPrimitiveDescription

          @Deprecated
          public static AnalysisEngineDescription createPrimitiveDescription(Class<? extends AnalysisComponent> componentClass,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         TypePriorities typePriorities,
                                                                                         FsIndexCollection indexes,
                                                                                         Capability[] capabilities,
                                                                                         ConfigurationParameter[] configurationParameters,
                                                                                         Object[] configurationValues,
                                                                                         Map<String,ExternalResourceDescription> externalResources)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(Class, TypeSystemDescription, TypePriorities, FsIndexCollection, Capability[], ConfigurationParameter[], Object[], Map)`
      Create and configure a primitive `AnalysisEngine`.
      Parameters:
        `componentClass` - a class that extends `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `indexes` - the Feature Structure Index collection used by this analysis engine to iterate over annotations in the `CAS`. If this is set explicitly here, any indexes declared via `FsIndexCollection` in the class are ignored.
        `capabilities` - the operations the component can perform in terms of consumed and produced types, sofa names, and languages. If this is set explicitly here, any capabilities declared via `SofaCapability` or `TypeCapability` in the class are ignored.
        `configurationParameters` - the configuration parameter declarations.
        `configurationValues` - the configuration parameter values.
        `externalResources` - external resources to bind to the analysis engine. (may be null)
      Returns:
        a description for this analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(List<Class<? extends AnalysisComponent>> componentClasses,
                                                                          TypeSystemDescription typeSystem,
                                                                          TypePriorities typePriorities,
                                                                          SofaMapping[] sofaMappings,
                                                                          Object... configurationData)
                                                                   throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static AnalysisEngineDescription createAggregateDescription(List<Class<? extends AnalysisComponent>> componentClasses,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         TypePriorities typePriorities,
                                                                                         SofaMapping[] sofaMappings,
                                                                                         Object... configurationData)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(AnalysisEngineDescription... analysisEngineDescriptions)
                                                                   throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static AnalysisEngineDescription createAggregateDescription(AnalysisEngineDescription... analysisEngineDescriptions)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(AnalysisEngineDescription...)`
      Create and configure an aggregate `AnalysisEngine` from several component descriptions.
      Parameters:
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(List<Class<? extends AnalysisComponent>> componentClasses,
                                                                          TypeSystemDescription typeSystem,
                                                                          TypePriorities typePriorities,
                                                                          SofaMapping[] sofaMappings,
                                                                          FlowControllerDescription flowControllerDescription,
                                                                          Object... configurationData)
                                                                   throws ResourceInitializationException

      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static AnalysisEngineDescription createAggregateDescription(List<Class<? extends AnalysisComponent>> componentClasses,
                                                                                         TypeSystemDescription typeSystem,
                                                                                         TypePriorities typePriorities,
                                                                                         SofaMapping[] sofaMappings,
                                                                                         FlowControllerDescription flowControllerDescription,
                                                                                         Object... configurationData)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(List, TypeSystemDescription, TypePriorities, SofaMapping[], FlowControllerDescription, Object...)`
      Create and configure an aggregate `AnalysisEngine` from several component classes.
      Parameters:
        `componentClasses` - a list of class that extend `AnalysisComponent` e.g. via `JCasAnnotator_ImplBase`
        `typeSystem` - A description of the types (may be null).
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `configurationData` - Any additional configuration parameters to be set. These should be supplied as (name, value) pairs, so there should always be an even number of parameters.
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(FlowControllerDescription flowControllerDescription,
                                                                          AnalysisEngineDescription... analysisEngineDescriptions)
                                                                   throws ResourceInitializationException

      A simplified factory method for creating an aggregate description for a given flow controller and a sequence of analysis engine descriptions
      Parameters:
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static AnalysisEngineDescription createAggregateDescription(FlowControllerDescription flowControllerDescription,
                                                                                         AnalysisEngineDescription... analysisEngineDescriptions)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngineDescription(FlowControllerDescription, AnalysisEngineDescription...)`
      A simplified factory method for creating an aggregate description for a given flow controller and a sequence of analysis engine descriptions
      Parameters:
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
        `analysisEngineDescriptions` - a list of analysis engine descriptions from which the aggregate engine is instantiated
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createEngineDescription

          public static AnalysisEngineDescription createEngineDescription(List<AnalysisEngineDescription> analysisEngineDescriptions,
                                                                          List<String> componentNames,
                                                                          TypePriorities typePriorities,
                                                                          SofaMapping[] sofaMappings,
                                                                          FlowControllerDescription flowControllerDescription)
                                                                   throws ResourceInitializationException

      A factory method for creating an aggregate description.
      Parameters:
        `analysisEngineDescriptions` - list of analysis engine descriptions.
        `componentNames` - list of component names - must be one name per description!
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

    - #### createAggregateDescription

          @Deprecated
          public static AnalysisEngineDescription createAggregateDescription(List<AnalysisEngineDescription> analysisEngineDescriptions,
                                                                                         List<String> componentNames,
                                                                                         TypePriorities typePriorities,
                                                                                         SofaMapping[] sofaMappings,
                                                                                         FlowControllerDescription flowControllerDescription)
                                                                                  throws ResourceInitializationException

      Deprecated. use `createEngine(List, List, TypePriorities, SofaMapping[], FlowControllerDescription)`
      A factory method for creating an aggregate description.
      Parameters:
        `analysisEngineDescriptions` - list of analysis engine descriptions.
        `componentNames` - list of component names - must be one name per description!
        `typePriorities` - The type priorities (may be null).
        `sofaMappings` - The SofA mappings (may be null).
        `flowControllerDescription` - the flow controller description to be used by this aggregate (may be null).
      Returns:
        a description for this aggregate analysis engine.
      Throws:
        `ResourceInitializationException` - if a failure occurred during production of the resource.

Copyright © 2012–2021 The Apache Software Foundation. All rights reserved.